// PrimeGen.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <math.h>
#include <time.h>
#include <vector>


#include <iostream>

using namespace std;

using std::cout;
using std::cin;
using std::endl;
const unsigned int primecount = 10000000;
const float interval = 10.0f;
const unsigned int pc5p = primecount/(100/interval);

int _tmain(int argc, _TCHAR* argv[])
{
	time_t start, end;
	double dt = 0;

	unsigned int count = 1;
	unsigned int curr = 3;
	unsigned int lastprime = 2;
	unsigned int check = 0;
	float root = 0.0f;

	bool prime = true;
	bool changed = true;
	vector<unsigned int> primes (1, 2);
	primes.reserve(primecount);

	cout << "Generating ten million primes. Test will take some time";

	time(&start);
	while(count < primecount)
	{
		root = sqrt((float)curr);
		//root = 

		prime = true;
		check = 0;
		while(check != primes.size() &&  primes[check] <= root && prime)
		{
			if(curr%primes[check] == 0)
				prime = false;
			++check;
		}
		if(prime)
		{
			++count;
			lastprime = curr;
			primes.push_back(curr);
			
			if(count % pc5p == 0)
			{
				cout << "\n" << (count / pc5p)*interval << "% Done" << " - " << lastprime;
			}
		}
		++curr;
	}
	time(&end);
	dt = difftime(end, start);
	cout << "\nTime taken: " << dt << " seconds";
	cout << "\nPrimes verified: " << count;
	cout << "\nLast prime verified: " << lastprime;
	cin.ignore();
	cin.get();


	return 0;
}

